package com.alihealth.d2d.provtest.utils;


import com.alibaba.fastjson.JSON;
import com.alihealth.d2d.provtest.enums.BuzStatusEnum;
import com.alihealth.d2d.provtest.enums.StatusEnum;

import java.util.HashMap;
import java.util.Map;

public class ResponseBuilder extends HashMap{

    public void status(Integer status){
        this.put("status", status);
    }

    public void message(String  message){
        this.put("message", message);
    }

    public void body(BuzStatusEnum buzStatusEnum){
        Map<String, Object> body = new HashMap<>();
        body.put("buz_status", buzStatusEnum.getBuzStatus());
        body.put("buz_message", buzStatusEnum.getBuzMessage());
        this.put("body", body);
    }

    public void body(Integer buzStatus,String buzMsg){
        Map<String, Object> body = new HashMap<>();
        body.put("buz_status", buzStatus);
        body.put("buz_message", buzMsg);
        this.put("body", body);
    }

    public static Map<String,Object> fail(BuzStatusEnum buzStatusEnumg){
        ResponseBuilder builder = new ResponseBuilder();
        builder.status(StatusEnum.FAILED.getStatus());
        builder.message(StatusEnum.FAILED.getMsg());
        builder.body(buzStatusEnumg);
        return builder.build();
    }

    public static Map<String,Object> success(){
        ResponseBuilder builder = new ResponseBuilder();
        builder.status(StatusEnum.SUCCESS.getStatus());
        builder.message(StatusEnum.SUCCESS.getMsg());
        builder.body(BuzStatusEnum.SUCCESS);
        return builder.build();
    }

    public static Map<String,Object> buzError(Integer buzStatus,String buzMessage){
        ResponseBuilder builder = new ResponseBuilder();
        builder.status(StatusEnum.BUZ_ERROR.getStatus());
        builder.message(StatusEnum.BUZ_ERROR.getMsg());
        builder.body(buzStatus,buzMessage);
        return builder.build();
    }

    public Map<String,Object> build(){
        Map<String, Object> responseMap = new HashMap<>();
        responseMap.put("resp", this);

        return responseMap;
    }

    public static void main(String[] args){
        System.out.println(JSON.toJSONString(fail(BuzStatusEnum.SIGN_CHECK_ERR)));
    }
}

